#!/bin/sh
#    This file is part of CrabEmu BIOS.
#
#    Copyright (C) 2008, 2009 Lawrence Sebald
#
#    CrabEmu BIOS is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License version 2 
#    as published by the Free Software Foundation.
#
#    CrabEmu BIOS is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with CrabEmu BIOS; if not, write to the Free Software
#    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

count=0
arg=""

echo_strings()
{
    num=$1
    count=$num
    arg=""

    shift

    while [ $num -gt 0 ]; do
        num=`expr $num - 1`
        shift
    done

    while [ $# -ge 3 ]; do
        count=`expr $count + 1`
        case "$3" in
            -l | -h | -f | -d)
                arg=$3
                break
                ;;
            *)
                echo "$3" >> $tmpfile
                shift
                ;;
        esac
    done
}

tmpfile=`mktemp /tmp/linkfile.XXXXXXXXXXXXXXXX`
outfile=$1

echo "[objects]" >> $tmpfile
echo_strings "0" "$@"
echo "" >> $tmpfile

echo "[libraries]" >> $tmpfile
if [ -n $arg ]; then
    if [ "$arg" = "-l" ]; then
        echo_strings "$count" "$@"
    fi
fi
echo "" >> $tmpfile

echo "[header]" >> $tmpfile
if [ -n $arg ]; then
    if [ "$arg" = "-h" ]; then
        echo_strings "$count" "$@"
    fi
fi
echo "" >> $tmpfile

echo "[footer]" >> $tmpfile
if [ -n $arg ]; then
    if [ "$arg" = "-f" ]; then
        echo_strings "$count" "$@"
    fi
fi
echo "" >> $tmpfile

echo "[definitions]" >> $tmpfile
if [ -n $arg ]; then
    if [ "$arg" = "-d" ]; then
        echo_strings "$count" "$@"
    fi
fi
echo "" >> $tmpfile

wlalink -"$2"d $tmpfile "$1"

rm $tmpfile